/*
 * Hexagonal Grid for Dynamic System Simulation
 * Author: niasw
 */

#include "hexgridplus.hpp"
using namespace hexagonplus;

double hexagonplus::IntegrateAround
       (const hexagondev& device, const double* valueset, int radius, int order1,
             double (*func)(const veci& vec1, const veci& vec2,
                            double value1, double value2))
{
    double integrate=0;
    int r,it1,it2; //current radius and iterator
    veci v1,v2;
    v1=device[order1];
    v2=v1;
    if (valueset) integrate+=func(v1,v1,valueset[order1],valueset[order1]);
    else integrate+=func(v1,v1,0,0);
    v2+=veci::adjstart;
    for (r=0;r<=radius;++r)
    {
        for (it1=0;it1<6;++it1)
        {
            for (it2=0;it2<r;++it2)
            {
                v2+=veci::adj[it1];
                if (valueset) integrate+=func(v1,v2,valueset[device[v1]],valueset[device[v2]]);
                else integrate+=func(v1,v2,0,0);
            }
        }
        v2+=veci::adjstart;
    }
    return integrate;
}
